Program lab_7;
uses
    graph;
type
    window=record
                 x1,y1,x2,y2,dx,dy:integer
    end;
    winfield=record
                   x1,y1,x2,y2,dx,dy:real
    end;
    grafic=record
                  mas:array[-100..100]of real;
                  min,max:real
    end;
    screengraphic=array[-100..100]of record
                                        x,y:integer
    end;
    vector=array[1..3]of real;
    matrix=array[1..3]of vector;
const
     matr:matrix=((1,0,0),(0,1,0),(0,0,1));

var
   w:window;
   scr:screengraphic;
   nums:grafic;
   x:real;

function f(x:real):real;
begin
     f:=exp(x)
end;

procedure tab(x:real);
var
   i:integer;
   k:real;
begin
     k:=x/100;
     with nums do
          begin
               mas[-100]:=f(-x);
               min:=mas[-100];
               max:=mas[-100];
               for i:=-99 to 100 do
                   begin
                        mas[i]:=f(i*k);
                        if mas[i]<min then
                           min:=mas[i]
                        else
                            if mas[i]>max then
                               max:=mas[i]
                   end
          end
end;

procedure graphtoscreen(bx,ex,by,ey:real);
var
   kx,ky,k:real;
   i:integer;
begin
     k:=ex/100;
     with w do
          begin
               kx:=dx/(ex-bx);
               ky:=dy/(ey-by);
          end;
     for i:=-100 to 100 do
         with scr[i] do
              begin
                   x:=round((i*k-bx)*kx+w.x1);
                   y:=w.y2-round((nums.mas[i]-by)*ky+w.y1)+w.y1
              end
end;

procedure setwindow(w:window);
var
   c:byte;
begin
     c:=getcolor;
     setcolor(green);
     with w do
          rectangle(x1,y1,x2,y2);
     setcolor(c)
end;

function getstep(k:real; var num,m,n:integer):real;
var
   t:real;
   i:integer;
begin
     t:=k*num;
     n:=0;
     if t<1 then
        begin
             while t<1 do
                   begin
                        t:=t*10;
                        dec(n)
                   end;
             if t>7.5 then
                begin
                     t:=1;
                     inc(n)
                end
             else
                 if t>3.5 then
                    t:=5
                 else
                     if t>1.5 then
                        t:=2
                     else
                         t:=1;
             m:=round(t);
             i:=n;
             while i<0 do
                   begin
                        t:=t/10;
                        inc(i)
                   end
        end
     else
         begin
              while t>10 do
                    begin
                         t:=t/10;
                         inc(n)
                    end;
              if t>7.5 then
                 begin
                      t:=1;
                      inc(n)
                 end
              else
                  if t>3.5 then
                     t:=5
                  else
                      if t>1.5 then
                         t:=2
                      else
                          t:=1;
              m:=round(t);
              i:=n;
              while i>0 do
                    begin
                         t:=t*10;
                         dec(i)
                    end
         end;
     num:=trunc(t/k);
     getstep:=t
end;

procedure setscale(w:window; x1,y1,x2,y2:real; var numx,numy,x0,y0:integer);

function getcenter(w1,w2:integer; a,b:real; f:boolean):integer;
var
   x:real;
begin
     if a*b<0 then
        begin
             x:=(abs(a)*w2+abs(b)*w1)/(abs(a)+abs(b));
             if not f then
                x:=w2+w1-x
        end
     else
         if a*b=0 then
            if (a=0)xor f then
               x:=w2
            else
                x:=w1
         else
             if (a>0)xor f then
                x:=w2
             else
                 x:=w1;
     getcenter:=round(x)
end;

var
   i,xx0,yy0,mx,nx,my,ny,b:integer;
   stepx,stepy,d,k:real;
   s:string;
begin
     k:=(x2-x1)/w.dx;
     stepx:=getstep(k,numx,mx,nx);
     k:=(y2-y1)/w.dy;
     stepy:=getstep(k,numy,my,ny);
     x0:=getcenter(w.x1,w.x2,x1,x2,true);
     line(x0,w.y1,x0,w.y2);
     y0:=getcenter(w.y1,w.y2,y1,y2,false);
     line(w.x1,y0,w.x2,y0);
     writeln('x * 10 ^ ',nx);
     writeln('y * 10 ^ ',ny);
     if x1>0 then
        begin
             d:=stepx;
             while d<x1 do
                   d:=d+stepx;
             if d=x1 then
                xx0:=w.x1-numx
             else
                 xx0:=w.x1+round((d-x1)*numx/stepx)-numx
        end
     else
         begin
              d:=stepx;
              xx0:=x0
         end;
     if nx>0 then
        while nx>0 do
              begin
                   dec(nx);
                   d:=d*10
              end
     else
         while nx<0 do
               begin
                    inc(nx);
                    d:=d/10
               end;
     b:=trunc(d);
     i:=xx0+numx;
     while i<w.x2 do
           begin
                line(i,y0-2,i,y0+2);
                str(b,s);
                outtextxy(i,y0-10,s);
                inc(i,numx);
                b:=b+mx
           end;
     if x2<0 then
        begin
             d:=-stepx;
             while d>x2 do
                   d:=d-stepx;
             if d=x2 then
                xx0:=w.x2+numx
             else
                 xx0:=w.x2+round((d-x2)*numx/stepx)+numx
        end
     else
         begin
              d:=-stepx;
              xx0:=x0
         end;
     if nx>0 then
        while nx>0 do
              begin
                   dec(nx);
                   d:=d*10
              end
     else
         while nx<0 do
               begin
                    inc(nx);
                    d:=d/10
               end;
     b:=trunc(d);
     i:=xx0-numx;
     while i>w.x1 do
           begin
                line(i,y0-2,i,y0+2);
                str(b,s);
                outtextxy(i-5,y0-10,s);
                dec(i,numx);
                b:=b-mx
           end;
     if y1>0 then
        begin
             d:=stepy;
             while d<y1 do
                   d:=d+stepy;
             if d=y1 then
                yy0:=w.y2+numy
             else
                 yy0:=w.y2-round((d-y1)*numy/stepy)+numy
        end
     else
         begin
              d:=stepy;
              yy0:=y0
         end;
     if ny>0 then
        while ny>0 do
              begin
                   dec(ny);
                   d:=d*10
              end
     else
         while ny<0 do
               begin
                    inc(ny);
                    d:=d/10
               end;
     b:=trunc(d);
     i:=yy0-numy;
     while i>w.y1 do
           begin
                line(x0-2,i,x0+2,i);
                str(b,s);
                outtextxy(x0+2,i-10,s);
                dec(i,numy);
                b:=b+my
           end;
     if y2<0 then
        begin
             d:=-stepy;
             while d>y2 do
                   d:=d-stepy;
             d:=d+stepy;
             if d=y2 then
                yy0:=w.y1-numy
             else
                yy0:=w.y1+round((d-y2)*numy/stepy)-numy
        end
     else
         begin
              d:=-stepy;
              yy0:=y0
         end;
     if ny>0 then
        while ny>0 do
              begin
                   dec(ny);
                   d:=d*10
              end
     else
         while ny<0 do
               begin
                    inc(ny);
                    d:=d/10
               end;
     b:=trunc(d);
     i:=yy0+numy;
     while i<w.y2 do
           begin
                line(x0-2,i,x0+2,i);
                str(b,s);
                outtextxy(x0+2,i-10,s);
                inc(i,numy);
                b:=b-my
           end
end;

procedure lineout(x1,y1,x2,y2:longint; win:window);

function code(x,y:longint):byte;
begin
     with win do
          code:=byte(x<x1)shl 3 or byte(x>x2)shl 2 or byte(y<y1)shl 1 or byte(y>y2)
end;

var
   c1,c2,c:byte;
   t:integer;
begin
     c1:=code(x1,y1);
     c2:=code(x2,y2);
     while (c1<>0)or(c2<>0) do
           if c1 and c2=0 then
              if c1<>0 then
                 begin
                      if c1 and 8<>0 then
                         begin
                              y1:=(win.x1-x1)*(y2-y1)div(x2-x1)+y1;
                              x1:=win.x1
                         end
                      else
                          if c1 and 4<>0 then
                             begin
                                  y1:=(win.x2-x1)*(y2-y1)div(x2-x1)+y1;
                                  x1:=win.x2
                             end
                          else
                              if c1 and 2<>0 then
                                 begin
                                      x1:=(win.y1-y1)*(x2-x1)div(y2-y1)+x1;
                                      y1:=win.y1
                                 end
                              else
                                  if c1 and 1<>0 then
                                     begin
                                          x1:=(win.y2-y1)*(x2-x1)div(y2-y1)+x1;
                                          y1:=win.y2
                                     end;
                      c1:=code(x1,y1)
                 end
              else
                  begin
                       t:=x1;
                       x1:=x2;
                       x2:=t;
                       t:=y1;
                       y1:=y2;
                       y2:=t;
                       c:=c1;
                       c1:=c2;
                       c2:=c
                  end
           else
               exit;
     line(x1,y1,x2,y2)
end;

procedure multiply(v:vector; m:matrix; var x:vector);
var
   i,j:byte;
begin
     for i:=1 to 3 do
         begin
              x[i]:=0;
              for j:=1 to 3 do
                  x[i]:=x[i]+v[j]*m[j,i]
         end
end;

procedure matrix_multiply(a,b:matrix; var x:matrix);
var
   i,j,k:byte;
begin
     for i:=1 to 3 do
         for j:=1 to 3 do
             begin
                  x[i,j]:=0;
                  for k:=1 to 3 do
                      x[i,j]:=x[i,j]+a[i,k]*b[k,j]
             end
end;

procedure graphic(bx,ex:real; numx,numy:integer);
var
   x0,y0:integer;

procedure graphic0(fnx:screengraphic; win:window);
var
   i:integer;
begin
     for i:=-99 to 100 do
         lineout(fnx[i-1].x,fnx[i-1].y,fnx[i].x,fnx[i].y,win)
end;

procedure graphic1(k,c,h,d:real);
var
   fn:screengraphic;
   v:vector;
   t,r:matrix;
   i:integer;
   xt:real;
begin
     fn:=scr;
     t:=matr;
     t[3,1]:=-x0;
     t[3,2]:=-y0;
     r:=matr;
     r[1,1]:=1/c;
     r[2,2]:=k;
     matrix_multiply(t,r,r);
     t:=matr;
     t[3,1]:=x0-h*w.dx/x/2;
     t[3,2]:=y0-d*w.dy/nums.max/2;
     matrix_multiply(r,t,t);
     for i:=-100 to 100 do
         begin
              v[1]:=fn[i].x;
              v[2]:=fn[i].y;
              v[3]:=1;
              multiply(v,t,v);
              fn[i].x:=round(v[1]);
              fn[i].y:=round(v[2])
         end;
     graphic0(fn,w)
end;

procedure graphic2;
var
   win:window;
   t,r:matrix;
   fn:screengraphic;
   i:integer;
   v:vector;
begin
     win:=w;
     with win do
          begin
               x1:=x0;
               dx:=x2-x1
          end;
     graphic0(scr,win);
     win:=w;
     with win do
          begin
               x2:=x0;
               dx:=x2-x1
          end;
     fn:=scr;
     t:=matr;
     t[3,1]:=-x0;
     r:=matr;
     r[1,1]:=-1;
     matrix_multiply(t,r,r);
     t:=matr;
     t[3,1]:=x0;
     matrix_multiply(r,t,t);
     for i:=-100 to 100 do
         begin
              v[1]:=fn[i].x;
              v[2]:=fn[i].y;
              v[3]:=1;
              multiply(v,t,v);
              fn[i].x:=round(v[1]);
              fn[i].y:=round(v[2])
         end;
     graphic0(fn,win)
end;

procedure graphic3;
var
   win:window;
   t,r:matrix;
   fn:screengraphic;
   i:integer;
   v:vector;
begin
     win:=w;
     with win do
          begin
               y2:=y0;
               dy:=y2-y1
          end;
     graphic0(scr,win);
     fn:=scr;
     t:=matr;
     t[3,2]:=-y0;
     r:=matr;
     r[2,2]:=-1;
     matrix_multiply(t,r,r);
     t:=matr;
     t[3,2]:=y0;
     matrix_multiply(r,t,t);
     for i:=-100 to 100 do
         begin
              v[1]:=fn[i].x;
              v[2]:=fn[i].y;
              v[3]:=1;
              multiply(v,t,v);
              fn[i].x:=round(v[1]);
              fn[i].y:=round(v[2])
         end;
     graphic0(fn,win)
end;

procedure graphic4;
var
   win:window;
   t,r:matrix;
   fn:screengraphic;
   i:integer;
   v:vector;
begin
     win:=w;
     with win do
          begin
               x1:=x0;
               dx:=x2-x1;
               y2:=y0;
               dy:=y2-y1
          end;
     graphic0(scr,win);
     win:=w;
     with win do
          begin
               x2:=x0;
               dx:=x2-x1;
               y2:=y0;
               dy:=y2-y1
          end;
     fn:=scr;
     t:=matr;
     t[3,1]:=-x0;
     r:=matr;
     r[1,1]:=-1;
     matrix_multiply(t,r,r);
     t:=matr;
     t[3,1]:=x0;
     matrix_multiply(r,t,t);
     for i:=-100 to 100 do
         begin
              v[1]:=fn[i].x;
              v[2]:=fn[i].y;
              v[3]:=1;
              multiply(v,t,v);
              fn[i].x:=round(v[1]);
              fn[i].y:=round(v[2])
         end;
     graphic0(fn,win);
     win:=w;
     with win do
          begin
               x1:=x0;
               dx:=x2-x1;
               y2:=y0;
               dy:=y2-y1
          end;
     fn:=scr;
     t:=matr;
     t[3,2]:=-y0;
     r:=matr;
     r[2,2]:=-1;
     matrix_multiply(t,r,r);
     t:=matr;
     t[3,2]:=y0;
     matrix_multiply(r,t,t);
     for i:=-100 to 100 do
         begin
              v[1]:=fn[i].x;
              v[2]:=fn[i].y;
              v[3]:=1;
              multiply(v,t,v);
              fn[i].x:=round(v[1]);
              fn[i].y:=round(v[2])
         end;
     graphic0(fn,win);
     win:=w;
     with win do
          begin
               x2:=x0;
               dx:=x2-x1;
               y2:=y0;
               dy:=y2-y1
          end;

     t:=matr;
     t[3,1]:=-x0;
     r:=matr;
     r[1,1]:=-1;
     matrix_multiply(t,r,r);
     t:=matr;
     t[3,1]:=x0;
     matrix_multiply(r,t,t);
     for i:=-100 to 100 do
         begin
              v[1]:=fn[i].x;
              v[2]:=fn[i].y;
              v[3]:=1;
              multiply(v,t,v);
              fn[i].x:=round(v[1]);
              fn[i].y:=round(v[2])
         end;
     graphic0(fn,win)
end;

var
   by,ey:integer;
   kx,ky,x,y:real;
   x1,y1,x2,y2:longint;
begin
     setwindow(w);
     by:=trunc(nums.min);
     ey:=trunc(nums.max);
     setscale(w,bx,by,ex,ey,numx,numy,x0,y0);
     with w do
          begin
               kx:=dx/(ex-bx);
               ky:=dy/(ey-by);
          end;
     graphtoscreen(bx,ex,by,ey);
     graphic0(scr,w);
     readln;
     setcolor(green);
     graphic1(2,1.5,1,3);
     readln;
     setcolor(red);
     graphic2;
     readln;
     setcolor(blue);
     graphic3;
     readln;
     setcolor(cyan);
     graphic4
end;

var
   gd,gm,numx,numy:integer;
begin
{     writeln(' न  뢮');
     with w do
          readln(x1,y1,x2,y2);
     writeln(' ।  x');
     readln(x);}
     with w do
     begin x1:=80; y1:=20; x2:=510; y2:=450; dx:=x2-x1; dy:=y2-y1 end;
     x:=3; numx:=70; numy:=50;
     gd:=detect;
     initgraph(gd,gm,'c:\bp\bgi');
     if graphresult<>grok then
        halt;
     tab(x);
     graphic(-x,x,numx,numy);
     readln;
     closegraph
end.